import m from 'mithril';

export interface Status {
	batteryVoltage: number;
	motorCurrent: number;
};

interface ApiStatus {
	v: number;
	c: number;
}

export class MonitorApi {
	constructor(private mockServer: boolean) {
	}
	
	async getStatus(): Promise<Status> {
		let apiStatus: ApiStatus;
		
		if(this.mockServer) {
			await new Promise(resolve => setTimeout(resolve, 200));
			apiStatus = {
				v: Math.random() * 20000 + 20000,
				c: Math.random() * 30000
			}
			setTimeout(() => m.redraw(), 0);
		} else {
			apiStatus = await m.request({
			    method: "GET",
			    url: "/api/status"
			});
		}
		
		return {
			batteryVoltage: apiStatus.v / 1000,
			motorCurrent: apiStatus.c / 1000
		};
	}
}
